package org.hardknockjava.lesson24.exercise01;

import java.util.HashMap;
import java.util.Locale;
import java.util.Map;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class Messages {
    private static final String BUNDLE_NAME = Messages.class.getPackageName() + ".messages"; //$NON-NLS-1$

    private static Map<Locale, ResourceBundle> bundleMap = null;
    
    private static Messages instance = null;
    
    public static Messages getInstance() {
        if (instance == null) {
            instance = new Messages();
            instance.setLocales(new Locale[0]);
        }
        return instance;
    }
    
    public static Messages getInstance(Locale... locales) {
        if (instance == null) {
            instance = new Messages();
            instance.setLocales(locales);
        }
        return instance;
    }
    
    public void setLocales(Locale... locales) {
        bundleMap = new HashMap<Locale, ResourceBundle>();
        for (Locale locale : locales) {
            ResourceBundle bundle = ResourceBundle.getBundle(BUNDLE_NAME, locale);
            bundleMap.put(locale, bundle);
        }
    }

    public String getString(String key, Locale locale) {
        try {
            ResourceBundle bundle = bundleMap.get(locale);
            if (bundle == null) {
                return null;
            }
            return bundle.getString(key);
        } catch (MissingResourceException e) {
            return '!' + key + '!';
        }
    }
}
