package org.hardknockjava.lesson24.exercise01;

import java.util.Locale;

public class Wilkommen {
    private static final String WELCOME = "wilkommen.welcome";
    private static final String STRANGER = "wilkommen.stranger";
    private static final String HAPPY_TO_SEE_YOU = "wilkommen.happy_to_see_you";
    private static final String STAY = "wilkommen.stay";
    private static final String TO_CABARET = "wilkommen.to_cabaret";

    private static final Locale[] LOCALE_ARRAY //
            = { Locale.GERMANY, Locale.FRANCE, Locale.US };
    
    private static final Messages MESSAGE_PROVIDER = Messages.getInstance(LOCALE_ARRAY); 

    public static void main(String[] args) {
        printPhrase(WELCOME);
        printPhrase(STRANGER);
        printPhrase(HAPPY_TO_SEE_YOU);
        printPhrase(STAY);
        printPhrase(TO_CABARET);
    }

    private static void printPhrase(String key) {
        StringBuilder phrase = new StringBuilder();
        String prefix = "";
        for (Locale locale : LOCALE_ARRAY) {
            phrase.append(prefix + MESSAGE_PROVIDER.getString(key, locale));
            prefix = ", ";
        }
        System.out.println(phrase);
        
    }
}
